/*
 *
 * (c) September 1998 by Mauro Marinilli
 *
 */


import java.awt.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.io.*;
import javax.media.j3d.*;

import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.geometry.ColorCube;

import java.applet.Applet;
import com.sun.j3d.utils.applet.MainFrame;


public class Viewer extends JFrame {
  JToolBar jToolBar1 = new JToolBar();
  JButton jButton1 = new JButton();
  ImageIcon open = new ImageIcon("open.gif");
  ImageIcon save = new ImageIcon("save.gif");
  ImageIcon newObj = new ImageIcon("new.gif");
  ImageIcon help = new ImageIcon("question.gif");
  ImageIcon treeIcon = new ImageIcon("treeIcon.gif");
  JButton saveB = new JButton();
  JButton jButton3 = new JButton();
  JButton jButton4 = new JButton();
  JSplitPane viewPanel;
  VirtualUniverse vUniverse;
  SceneTreeModel model;
  SceneTreePanel panel;
  JPanel panelView;
  VU applet;


  SimpleUniverse u;

  public Viewer() {
    try  {
      draw();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

//
  getContentPane().setLayout(new BorderLayout());
  Canvas3D c = new Canvas3D(null);
  getContentPane().add("Center", c);
  BranchGroup objRoot = new BranchGroup();
  u = new SimpleUniverse(c);
  vUniverse = new VirtualUniverse();
  objRoot.addChild(new ColorCube(0.1));
  objRoot.compile();
  u.addBranchGraph(objRoot);
//
  }

  private void draw() throws Exception {
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    jButton1.setMaximumSize(new Dimension(33, 33));
    jButton1.setIcon(open);
    jButton1.setToolTipText("load a VirtualUniverse object from file");
    jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jButton1_mouseClicked(e);
      }
    });
    saveB.setIcon(save);
    saveB.setMaximumSize(new Dimension(33, 33));
    saveB.setToolTipText("save this VirtualUniverse object to a file");
    saveB.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        saveB_mouseClicked(e);
      }
    });
    jButton3.setMaximumSize(new Dimension(33, 33));
    jButton3.setIcon(newObj);
    jButton3.setToolTipText("create a blank VirtualObject");

    jButton4.setMaximumSize(new Dimension(33, 33));
    jButton4.setIcon(help);
    jButton4.setToolTipText("about Scene Viewer");
    jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jButton4_mouseClicked(e);
      }
    });
    setIconImage(treeIcon.getImage());
    this.getContentPane().add(jToolBar1, BorderLayout.NORTH);
    jToolBar1.add(jButton1, null);
    jToolBar1.add(saveB, null);
    jToolBar1.add(jButton3, null);
    jToolBar1.add(jButton4, null);

    applet = new Simple3D();
    VirtualUniverse vu = applet.getVU();

    model  = new SceneTreeModel(vu);
    panel  = new SceneTreePanel(model);
    panelView = new JPanel();

    Canvas3D c = new Canvas3D(null);

    JPanel panelStatus = new JPanel();

    panel.getTree().addTreeSelectionListener( new TreeListener( model ) );

    JScrollPane viewPanel2 = new JScrollPane(panelStatus);

    JScrollPane treeScroller = new JScrollPane( panel );
    viewPanel = new JSplitPane(
       JSplitPane.HORIZONTAL_SPLIT, treeScroller, viewPanel2 );


    this.getContentPane().add(viewPanel);

    viewPanel.setContinuousLayout( true );
    setTitle("Scene Graph Viewer");
    setResizable(false);
    setSize(500,300);
    show();
    System.out.println(vu.numLocales());


    MainFrame m = new MainFrame(applet,256,256);

  }

  void this_windowClosing(WindowEvent e) {
    System.exit(0);
  }

  void jButton1_mouseClicked(MouseEvent e) {
    FileDialog fd = new FileDialog(this);
    fd.setFile("*.obj");
    fd.show();                             
    if (fd.getFile()==null) return;
    if (!fd.getFile().endsWith(".obj")) return;
//    if (!fd.getFile().endsWith(".class")) return;

    File f = new File(fd.getDirectory(), fd.getFile());


  }

  void jButton4_mouseClicked(MouseEvent e) {
    InfoDialog info = new InfoDialog(this);
  }


  void saveB_mouseClicked(MouseEvent e) {
    FileDialog fd = new FileDialog(this,"Save .obj file",FileDialog.SAVE);
    fd.setFile("*.obj");
    fd.show();
    if (fd.getFile()==null) return;
    SerializeVU v = new SerializeVU(applet.getVU(),fd.getFile());

  }


  VirtualUniverse loadVU(String fileName){

    Object ob = new Object();
    try {
      FileInputStream ostream = new FileInputStream(fileName);
      ObjectInputStream in = new ObjectInputStream(ostream);
      ob = in.readObject();
      in.close();

    } catch (Exception ie) {
      System.out.println("deserializing:"+fileName+ie.toString());
    }
    return null;
  }

  public static void main(String[] args) {
    Viewer Viewer1 = new Viewer();
  }


    protected static class TreeListener implements TreeSelectionListener {
        SceneTreeModel model;
        public TreeListener( SceneTreeModel mdl ) {
            model = mdl;
        }
        public void valueChanged( TreeSelectionEvent e ) {
        }
    }


}

